<?php

namespace Sabre\TokenCreate;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'TokenCreateRQ' => '\\Sabre\\TokenCreate\\Structs\\TokenCreateRQ',
            'TokenCreateRS' => '\\Sabre\\TokenCreate\\Structs\\TokenCreateRS',
            'Success' => '\\Sabre\\TokenCreate\\Structs\\Success',
            'SignatureType' => '\\Sabre\\TokenCreate\\Structs\\SignatureType',
            'SignatureValueType' => '\\Sabre\\TokenCreate\\Structs\\SignatureValueType',
            'SignedInfoType' => '\\Sabre\\TokenCreate\\Structs\\SignedInfoType',
            'CanonicalizationMethodType' => '\\Sabre\\TokenCreate\\Structs\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\Sabre\\TokenCreate\\Structs\\SignatureMethodType',
            'ReferenceType' => '\\Sabre\\TokenCreate\\Structs\\ReferenceType',
            'TransformsType' => '\\Sabre\\TokenCreate\\Structs\\TransformsType',
            'TransformType' => '\\Sabre\\TokenCreate\\Structs\\TransformType',
            'DigestMethodType' => '\\Sabre\\TokenCreate\\Structs\\DigestMethodType',
            'KeyInfoType' => '\\Sabre\\TokenCreate\\Structs\\KeyInfoType',
            'KeyValueType' => '\\Sabre\\TokenCreate\\Structs\\KeyValueType',
            'RetrievalMethodType' => '\\Sabre\\TokenCreate\\Structs\\RetrievalMethodType',
            'X509DataType' => '\\Sabre\\TokenCreate\\Structs\\X509DataType',
            'X509IssuerSerialType' => '\\Sabre\\TokenCreate\\Structs\\X509IssuerSerialType',
            'PGPDataType' => '\\Sabre\\TokenCreate\\Structs\\PGPDataType',
            'SPKIDataType' => '\\Sabre\\TokenCreate\\Structs\\SPKIDataType',
            'ObjectType' => '\\Sabre\\TokenCreate\\Structs\\ObjectType',
            'ManifestType' => '\\Sabre\\TokenCreate\\Structs\\ManifestType',
            'SignaturePropertiesType' => '\\Sabre\\TokenCreate\\Structs\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\Sabre\\TokenCreate\\Structs\\SignaturePropertyType',
            'DSAKeyValueType' => '\\Sabre\\TokenCreate\\Structs\\DSAKeyValueType',
            'RSAKeyValueType' => '\\Sabre\\TokenCreate\\Structs\\RSAKeyValueType',
            'Envelope' => '\\Sabre\\TokenCreate\\Structs\\Envelope',
            'Header' => '\\Sabre\\TokenCreate\\Structs\\Header',
            'Body' => '\\Sabre\\TokenCreate\\Structs\\Body',
            'Fault' => '\\Sabre\\TokenCreate\\Structs\\Fault',
            'detail' => '\\Sabre\\TokenCreate\\Structs\\Detail',
            'Manifest' => '\\Sabre\\TokenCreate\\Structs\\Manifest',
            'Reference' => '\\Sabre\\TokenCreate\\Structs\\Reference',
            'Schema' => '\\Sabre\\TokenCreate\\Structs\\Schema',
            'MessageHeader' => '\\Sabre\\TokenCreate\\Structs\\MessageHeader',
            'Service' => '\\Sabre\\TokenCreate\\Structs\\Service',
            'MessageData' => '\\Sabre\\TokenCreate\\Structs\\MessageData',
            'SyncReply' => '\\Sabre\\TokenCreate\\Structs\\SyncReply',
            'MessageOrder' => '\\Sabre\\TokenCreate\\Structs\\MessageOrder',
            'AckRequested' => '\\Sabre\\TokenCreate\\Structs\\AckRequested',
            'Acknowledgment' => '\\Sabre\\TokenCreate\\Structs\\Acknowledgment',
            'ErrorList' => '\\Sabre\\TokenCreate\\Structs\\ErrorList',
            'Error' => '\\Sabre\\TokenCreate\\Structs\\Error',
            'StatusResponse' => '\\Sabre\\TokenCreate\\Structs\\StatusResponse',
            'StatusRequest' => '\\Sabre\\TokenCreate\\Structs\\StatusRequest',
            'sequenceNumber.type' => '\\Sabre\\TokenCreate\\Structs\\SequenceNumber_type',
            'PartyId' => '\\Sabre\\TokenCreate\\Structs\\PartyId',
            'To' => '\\Sabre\\TokenCreate\\Structs\\To',
            'From' => '\\Sabre\\TokenCreate\\Structs\\From',
            'Description' => '\\Sabre\\TokenCreate\\Structs\\Description',
            'Security' => '\\Sabre\\TokenCreate\\Structs\\Security',
            'UsernameToken' => '\\Sabre\\TokenCreate\\Structs\\UsernameToken',
        );
    }
}
